#ifndef __MERLINPARAMETERS_H__
#define __MERLINPARAMETERS_H__

#include "StringBasics.h"
#include "Parameters.h"

class MerlinParameters : public ParameterList
   {
   public:
      String pedigreeFile;
      String dataFile;
      String mapFile;
      String freqFile;
      int    alleleFrequencies;
      int    random_seed;

      static int    maxMegabytes;
      static bool   trimPedigree;
      static bool   simulateNull;
      static bool   saveReplicate;
      static bool   varianceComponents;
      static bool   associationAnalysis;
      static bool   associationAnalysis2df;
      static bool   associationAnalysis3models;
      static String qtlModelFile;
      static bool   inverseNormal;
      static bool   inverseNormalResiduals;
      static bool   writeFrequencyFile;
      static bool   fitErrorRate;
      static int    reruns;
      static double clusterDistance;
      static double clusterRsquared;
      static String clusterFile;
      static bool   writeClusters;

      MerlinParameters();

      virtual void Read(int argc, char ** argv, int start = 1);
   };

#define  FREQ_ML        99   // For maximum likelihood allele frequencies

class AlleleFrequencyParameter : public Parameter
   {
   public:
   AlleleFrequencyParameter(char c, const char * desc, int & how, String & file);

   virtual void Status();

   protected:
      String * filename;
      String status;

      virtual void Translate(const char * value);
   };


#endif

