#ifndef __NPL_ASP_H__
#define __NPL_ASP_H__

#include "Pedigree.h"
#include "Mantra.h"
#include "Tree.h"

class NPL_ASP_Tree : public Tree
   {
   public:
      void    ScoreNPL(Mantra & f, int affection);

      // Dummy virtual destructor
      virtual ~NPL_ASP_Tree() { }

   private:
      int    RecursivelyScoreNPL(Mantra & m, int bit);
      bool   isRedundantNPL(Mantra & m, int pivot);
      virtual double CalculateNPL(Mantra & m) = 0;
      virtual void   PrepareForScoring(Mantra & m);

   };

class NPL_ALL : public NPL_ASP_Tree
   {
   public:
      // Dummy virtual destructor
      virtual ~NPL_ALL() { }

   protected:
      virtual double CalculateNPL(Mantra & m);
      virtual void   PrepareForScoring(Mantra & m);

      static const double factors[20];
      static const double reciprocals[20];

      IntArray counts;
      int      permutations;
      double   permutationWeight;

   private:
      double   ScoreSubset(Mantra & m, IntArray & affecteds);
      IntArray subset, graph;
   };

class NPL_Pairs : public NPL_ASP_Tree
   {
   public:
      // Dummy virtual destructor
      virtual ~NPL_Pairs() { }

   protected:
      virtual double CalculateNPL(Mantra & m);
   };

class NPL_Pairs_For_Simwalk2 : public NPL_ASP_Tree
   {
   public:
      // Dummy virtual destructor
      virtual ~NPL_Pairs_For_Simwalk2() { }

   protected:
      virtual double CalculateNPL(Mantra & m);
   };

class NPL_Pairs_Maternal : public NPL_ASP_Tree
   {
   public:
      // Dummy virtual destructor
      virtual ~NPL_Pairs_Maternal() { }

   protected:
      virtual double CalculateNPL(Mantra & m);
   };

class NPL_Pairs_Paternal : public NPL_ASP_Tree
   {
   public:
      // Dummy virtual destructor
      virtual ~NPL_Pairs_Paternal() { }

   protected:
      virtual double CalculateNPL(Mantra & m);
   };

#endif