#ifndef __NPL_QTL_H__
#define __NPL_QTL_H__

#include "Pedigree.h"
#include "Mantra.h"
#include "Tree.h"

class NPL_QTL : public Tree
   {
   public:
      void   ScoreWithMeanZero(Mantra & m, int trait);
      void   ScoreWithSampleMean(Mantra & m, int trait);

   private:
      void   ScoreNPL(Mantra & m, int trait, double mean);
      void   ScoreMeans(Pedigree & ped);

      int    RecursivelyScoreNPL(Mantra & m, int bit);
      bool   isRedundantNPL(Mantra & m, int pivot);
      double CalculateNPL(Mantra & m);

      Vector avg;

      // Phenotypic means calculated once per run
      static Vector traitMeans;
   };

#endif
