#ifndef _PARAMETRICLIKELIHOOD_H_
#define _PARAMETRICLIKELIHOOD_H_

#include "Houdini.h"
#include "DiseaseModel.h"

class ParametricLikelihood : public FuzzyInheritanceTree
   {
   public:
      ParametricLikelihood();
      ~ParametricLikelihood();

      DisModel * model;

   protected:
      virtual int    CountAlleles(Mantra & m);
      virtual bool   ShortScoreVectors(Mantra & m);
      virtual void   FillPenetranceMatrix(Mantra & m);
      virtual bool   isPhenotyped(Mantra & m, int i);

      virtual double GetAlleleFrequency(int founder, int allele);
      virtual void   UpdateAlleles(int founder, int carrier);
      virtual void   UndoAlleles(int founder, int carrier);

      virtual double JointProbability(Mantra & m);

      virtual void   SetupAlleleList(Mantra & m);
      virtual void   CleanUpAlleleList(Mantra & m);

      virtual bool IdenticalPenetrances(int founder1, int founder2);
      virtual void SwapPenetrances(int founder1, int founder2);

   private:
       IntArray compatibleAlleles;
   };

#endif

