#include "ClusterInfo.h"
#include "Pedigree.h"

ClusterInfo::ClusterInfo()
   { markers = 0; }

ClusterInfo::ClusterInfo(int nMarkers)
   { SetMarkerCount(nMarkers); }

void ClusterInfo::SetMarkerCount(int count)
   {
   alleleCounts.Dimension(count);
   alleleCounts.Set(1);

   markerIds.Dimension(count);
   markerIds.Zero();

   markers = count;
   }

ClusterInfo & ClusterInfo::operator = (ClusterInfo & rhs)
   {
   alleleCounts = rhs.alleleCounts;
   markerIds = rhs.markerIds;
   markers = rhs.markers;

   return *this;
   }

void ClusterInfo::UpdateAlleleCounts()
   {
   for (int i = 0; i < markers; i++)
      alleleCounts[i] = Pedigree::GetMarkerInfo(markerIds[i])->freq.Length() - 1;
   }

